// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cassert>

class Date {
public:
      // The public: interface for Date goes here...
protected:
  void testInvariant() const throw();
  int day_;
  int month_;
  int year_;
};

inline void Date::testInvariant() const throw()
{
  assert(day_ >= 1 && day_ <= 31);
  assert(month_ >= 1 && month_ <= 12);
}
