// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
using namespace std;

class Barney { };

class Fred {
public:
  // ...
private:
#ifdef STATIC_CONST_DATA_MEMBER_BUG
  static const int  i_;
  static const char c_;
#else
  static const int  i_ = 42;
  static const char c_ = 'z';
#endif

  static const float x_;
  static const string s_;
  static const Barney b_; 
};

//#include "Fred.hpp"

const float Fred::x_ = 3.14;
const string Fred::s_ = "Hello";
const Barney Fred::b_;
