// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <string>
using namespace std;

class Person {
public:
  Person(const string& name) throw(bad_alloc);
  // ...
protected:
  string name_;
};

Person::Person(const string& name) throw(bad_alloc)
: name_(name)  // The initialization list copies name into name_
{
    // Note: No assignment here since the init list copies name into name_
}

int main()
{
  Person fred("Fred Flintstone");
  // ...
}
