// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  void operator++ ()    throw();
  void operator++ (int) throw();
};

void Fred::operator++ ()    throw() { cout << "prefix: ++i\n"; }
void Fred::operator++ (int) throw() { cout << "postfix: i++\n"; }

int main()
{
  Fred i;
  ++i;
  i++;
}
