// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cstdarg>

class Fred {
public:
  Fred() throw();
  Fred(const Fred& x) throw();
  Fred& operator= (const Fred& x) throw();
 ~Fred();
};

void doSomethingWith(Fred x) throw();

void f(int count, Fred first...) throw()
{
  va_list ap;
  va_start(ap, first);
  doSomethingWith( first );
  for (int i = 1; i < count; ++i) {
    Fred x = va_arg(ap, Fred);
    doSomethingWith( x );
  }
}

int main()
{
  Fred a, b, c;
  f(3, a, b, c);
}
