// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class B {
public:
  int f(int, char, float) throw();
protected:
  int g(double, char) throw();
};

class PrivD : private B {
public:
  using B::f;    // Note: omit the parameter declarations
};

class PrivD2 : private B {
public:
  int g(double d, char c) throw();
};

inline int PrivD2::g(double d, char c) throw()
{ return B::g(d, c); }
