// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#ifndef CAR_HPP
#define CAR_HPP

#include <string>
using namespace std;

class Car {
public:
  virtual void startEngine();     // Line 1
  virtual bool isRunning() const; // Line 2
  virtual void tuneRadioTo(const string& band, int freq); // Line 3
protected:
  bool isRunning_;                // Line 4
  bool radioOnAM_;
  int  radioFreq_;
};

#endif
