// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Base {
public:
  virtual void f() throw() = 0;
  virtual void g() throw() = 0;
};

class Derived : public Base {
public:
  virtual void f() throw();
};

void Derived::f() throw()
{ }

class Derived2 : public Derived {
public:
  virtual void g() throw();
};

void Derived2::g() throw()
{ }

void sample() throw()
{ Derived2 x; }  // ok: Derived2 is a concrete class
