// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class X {
public:
  void f() throw();
};

void X::f() throw()
{ }

int main()
{
  X x;
  x.f();   //OK

  #ifdef GENERATE_ERROR
    //the following error is caught at compile-time
    //there is no need for runtime checks
    x.g();
  #endif
}
