// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
using namespace std;

int main()
{
  string a = "fred";
  string b;

  #if 1
    // Good: let the object copy itself:
    b = a;
  #else
    // Bad: manipulates the object's bits:
    memcpy(&b, &a, sizeof(string));
  #endif
}
