// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

// This is C++ code
extern "C" {
  void sample(int i, char c, float x) throw();
}

void sample(int i, char c, float x) throw()
{
         // The C++ code that defines the function goes here
}

/* This is C code */
void sample(int i, char c, float x);

void myCfunction()
{
  // ...
  sample(42, 'a', 3.14);
  // ...
}
